<?php

namespace Lucent\Schema\Ui;

use Lucent\Schema\FieldInfo;
use Lucent\Schema\FieldInterface;
use Lucent\Schema\FieldType;
use Lucent\Schema\Nullable;
use Lucent\Schema\Validator\RequiredInterface;

class Color implements FieldInterface, RequiredInterface
{
    public FieldInfo $info;


    public function __construct(
        public string $name,
        public string $label,
        public bool   $required = false,
        public bool   $nullable = false,
        public string $default = "",
        public string $help = "",
        public bool   $readonly = false,
        public string $optionsFrom = "",
        public string $optionsField = "",
        public bool   $optionsSuggest = false,
        public string $group = "",
    )
    {
        $this->info = new FieldInfo("color", "Color", FieldType::STRING);
    }

    public function format(array $input, array $output): array
    {
        $value = $input[$this->name] ?? null;
        $output[$this->name] = (new Nullable($this->nullable, $value, ""))->value();
        return $output;
    }

    public function failRequired(mixed $value): bool
    {
        return empty(trim($value));
    }
}

